/*                                                           6/27/97

GET_HTTP_DATA is a program developed for OPENVMS and UCX in order to 
retrieve data through an ODBC link and a NT server from either MS-Access
or MS-SQL datasources.  The program was written by Charles Cooper at
the University of Texas School of Public Health by modifying on of the UCX 
Sample programs supplied by Digital.  The program can be distributed freely
as is but should not be sold.  I ask that any enhancements to the program 
be sent to me at cooper@utsph.sph.uth.tmc.edu or perhaps distributed 
freely on the net for others to use.

Charles Cooper
Director of Research Computing
University of Texas
School of Public Health
1200 Herman Pressler
Room 806
Houston, Tx.

cooper@utsph.sph.uth.tmc.edu


*/




/*

#include <errno.h>
#include <sys/types.h> 
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/uio.h>
*/
#include <unixio.h>
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <types.h>
#include <socket.h>
#include <in.h>
#include <netdb.h>
#include <inet.h>
#include <string.h>
#include <ucx$inetdef.h>



#ifndef vms
#define TRUE 1
#define FALSE 0
#endif

FILE *infile;      
FILE *scrf;
FILE *outf;
FILE *deff;


main(argc,argv)
int argc;
char **argv;
{
      int sock_1;
/*
      static char message[]="GET /www/scripts/person3.idc\n";
    static char message[]="GET /myscripts/facstaff.idc\n"; */
static char message[80];

/*     data expected input file file specified on command line */

static char http[80];
static char scrfile[80];
static char outfile[80];
static char deffile[80];

static char message2[2000];
static struct sockaddr_in sock2_name;
      struct hostent	hostentstruct;
      struct hostent	*hostentptr;
      static char	hostname[256];
      int	flag;
      int 	slng;
      int 	retval;
      int	shut = FALSE;
      int 	i;
      int cleanup();
      void process_data();
      if (argc != 4 )
      		{ 
      		 printf("Usage: HOST PORT DESCRIP FILE \n");
      		 exit(0);
      		}



      if((infile=fopen(argv[3],"r")) == NULL){
      		printf("Problem opening :[%s]",argv[3]);
      		exit(0);
      			}



/*
      Read in the 4 components needed from the definition file 

       file to get             e.g    GET /myscripts/facstaff.idc
       scratch file anme       e.g.   temp.dat
       formatted output file   e.g.   facstaff.dat
       definition output file  e.g.   facstaff.def

*/



      fgets(http,80,infile);

      fgets(scrfile,80,infile);
      scrfile[strlen(scrfile)-1]='\0';
      fgets(outfile,80,infile);
      outfile[strlen(outfile)-1]='\0';
      fgets(deffile,80,infile);
      deffile[strlen(deffile)-1]='\0';


      if ((sock_1 = socket(AF_INET, SOCK_STREAM, 0)) == -1)
      		{
      		 perror("socket");
      		 exit(0);
      		}

      if ((hostentptr = gethostbyname (argv[1])) == NULL)
      		{
      		perror("gethostbyname");
      		cleanup(shut,sock_1);
      		}

      hostentstruct = *hostentptr;

      sock2_name.sin_family = hostentstruct.h_addrtype;
      sock2_name.sin_port = htons(atoi(argv[2]));
      sock2_name.sin_addr = * ((struct in_addr *) hostentstruct.h_addr);

      retval = connect(sock_1,&sock2_name, sizeof(sock2_name));

      if (retval)
      	{
      	perror("connect");
        cleanup(shut, sock_1);
      	}

      flag=0;
      
      strcpy(message,http);
      strcat(message,"\n");

      retval = send(sock_1, message, sizeof(message), flag);
      if(retval < 0){
      		printf("Error opening connection to [%s]",message);
      		exit(0);
      		}

      if((scrf=fopen(scrfile,"w")) == NULL){
      	printf("Problem opening :[%s]",scrfile);
      	exit(0);
      	};


      while((retval = recv(sock_1, message2,sizeof(message2), flag)) > 0)
      {

      	for (i=0; i < retval; i++){
      			putc(message2[i],scrf);
      			}
      };

      fclose(scrf);


      process_data(scrfile,outfile,deffile);

      if (retval < 0)
      	{
      		perror ("send");
      		shut = TRUE;
       	}

      cleanup(shut, sock_1);
 }


cleanup(shut, socket)

int	shut;
int	socket;

{
      int 	retval;
      if(shut){
      		retval = shutdown(socket,2);
      		if (retval == -1)
      			perror("shutdown");
      		}

retval=close(socket);
if (retval)
      perror("close");
      exit(0);
}


void process_data(scrfile,outfile,deffile)
char *scrfile;		/*  scratch file */
char *outfile;		/*  formatted output file */
char *deffile;		/*  definition file */
{

      int mxbuf=500;      
      char buf[500];
      int i,num,str,stp;
      void process_str();
      char x;
      num=0;
      str=0;
      stp=0;


      if((scrf=fopen(scrfile,"r")) == NULL){
      	printf("Problem opening :[%s]",scrfile);
      	exit(0);
      }
      if((outf=fopen(outfile,"w")) == NULL){
      	printf("Problem opening :[%s]",outfile);
      	exit(0);
      }
      if((deff=fopen(deffile,"w")) == NULL){
      	printf("Problem opening :[%s]",deffile);
      	exit(0);
      }


      printf("Output written to: %s\n ",outfile);
      printf("Description written to: %s\n ",deffile);


      for(i=0;i<=mxbuf;i++)buf[i]=' ';

      while ((x=getc(scrf)) != EOF)
      {
      
      	if (x=='*'){
      		str++;
      		}

      	if (str=0)goto nx;

        if(x != '*' && str==1)str=0;

      	if(x=='$')stp++;

        if(x != '$' && stp==1)stp=0;
        if(x < ' ' || x > '}') x=' ';
        buf[num]=x;
        buf[num+1]=0;
  	num++;

/*        printf("%d %c \n",num,x);  */

        if(stp == 2){

        str=0;
        stp=0;

      	process_str(num,buf);
        for (i=1; i<=num; i++){
      			buf[i]=' ';
      			}

        num=0;
  		    }
      nx:
      continue;

      }
      
      fclose(outf);
      fclose(deff);
      fclose(scrf);
      fclose(infile);
      exit(0);
}

void process_str(num,str)
int num;
char *str;
{
      int i,j,k,slng,lng,vcnt;
      int flag;
      char *sin=str;
      char *bg,*en,*bg2,*en2,*bg3;
      char delim,sep;
      static int ilng[500];
      int mxbuf=500;
      static int cnt=0;
      char buf[500];
      char strout[2000];
      char wth[10];

      slng=strlen(str);
      delim='"';
      for(i=1;i<=10;i++)wth[i]=' ';
/*      for(i=0;i<=2000;i++)strout[i]=' '; */
      strout[0]=0;

      sep=';';
      flag=0;
      cnt++;
      vcnt=0;
/*      if(cnt==4)exit(0); */

      for (i=0;i<=mxbuf;i++){
      			buf[i]=' ';      
      	      			
      			}
      

      for (i=0; i <= slng; i++){
      	if(*sin != delim){
      		sin++;
      		continue;
            	}

        if (flag==0){
      	        sin++;
      		bg=sin;
      		flag=1;
      		continue;
      		}

        if (flag==1){
     	 	en=sin-1;
     	 	lng=(en-bg)+1;

      		if (cnt==1){
      			bg2=bg;

      			for(j=0; j<=lng; j++){
      			   if(*bg2=='('){
      				bg2++;
      				bg3=bg2;

      				for(k=0; k <= (en-bg2)+1; k++){

      					if(*bg3==')'){
      					  strncpy(wth,bg2,(bg3-bg2));
      					  wth[bg3-bg2]=0;
      					 sscanf(wth,"%d",&ilng[vcnt]);

      					 break;
      						};
      					bg3++;
      					    
      				}
      				break;
      			   }
      			   bg2++;
      			}      					
      			lng=(bg2-bg)-2;
      			
      
      		  }


      		strncpy(buf,bg,lng);      	
      		buf[lng]=0;


j=strlen(buf);

if(cnt==1)fprintf(deff,"%5d%s\n",ilng[vcnt],buf);

if(vcnt==0)strcpy(strout,buf);
if(vcnt!=0)strcat(strout,buf);
k=(ilng[vcnt]-j);


for(j=0;j<k;j++)strcat(strout," ");


vcnt++;

      		flag=0;
      		sin++;
      	        for (j=0;j<mxbuf;j++)buf[j]=' ';      

      		
                  }
     } 
if(cnt>1)fprintf(outf,"%s\n",strout);

}

